aboutsummaryrefslogtreecommitdiffstats
path: root/tests
diff options
context:
space:
mode:
authorBryan Quigley <bryan.quigley@canonical.com>2019-12-12 17:04:19 -0800
committerJake Hunsaker <jhunsake@redhat.com>2020-02-04 12:59:09 -0500
commitc55f219b0a9cb7bdb5b624864f7d785c7ff1580f (patch)
treedac10dbe8d780823f295a80b1471e490e478c438 /tests
parent5e95ee64d1a25fefd2feddcee52f9e5f9815e5ec (diff)
downloadsos-c55f219b0a9cb7bdb5b624864f7d785c7ff1580f.tar.gz
[travis] Move to single test script and use travis job matrix
Move all the sosreport runs to a simple bash script: tests/simple.sh so it can be called multiple times. This also makes it possible to run locally. The travis job matrix let's us have 2 Ubuntu native sos runs against installed python, while letting us to also continue to do the old style python runs. Ideally, we can utilize this to do Fedora/CentOS/RHEL jobs in the future. Python 3.4 testing was also dropped - as it seems to not be as well used (many test failures due to not being available). Python 3.8 testing was added. pycodestyle will only run once with the bionic version. Resolves: #1896 Signed-off-by: Bryan Quigley <bryan.quigley@canonical.com> Signed-off-by: Jake Hunsaker <jhunsake@redhat.com>
Diffstat (limited to 'tests')
-rwxr-xr-xtests/simple.sh111
1 files changed, 111 insertions, 0 deletions
diff --git a/tests/simple.sh b/tests/simple.sh
new file mode 100755
index 00000000..6f4fc466
--- /dev/null
+++ b/tests/simple.sh
@@ -0,0 +1,111 @@
+#/bin/bash
+# A quick port of the travis tests to bash, requires root
+# TODO
+# * look into using a framework..
+# * why --dry-run fails?
+# * why --experimental fails?
+# * https://github.com/sosreport/sos/issues/1921
+# * make it better validate archives and contents
+
+PYTHON=${1:-/usr/bin/python3}
+SOSPATH=${2:-./sosreport}
+
+NUMOFFAILURES=0
+
+run_expecting_sucess () {
+ #$1 - is command options
+ #$2 - kind of check to do, so far only extract
+ FAIL=false
+ # Make sure clean
+ rm -f stderr stdout /tmp/sosreport*.tar.*
+ rm -rf /tmp/sosreport_test/
+
+ echo "######### RUNNING $1 #########"
+ $PYTHON $SOSPATH $1 2> stderr 1> stdout
+
+ if [ $? -eq 0 ]; then
+ echo "### Success"
+ else
+ echo "!!! FAILED !!!"
+ FAIL=true
+ fi
+
+ if [ -s stderr ]; then
+ FAIL=true
+ echo "!!! FAILED !!!"
+ echo "### start stderr"
+ cat stderr
+ echo "### end stderr"
+ fi
+
+ echo "### start stdout"
+ cat stdout
+ echo "### end stdout"
+
+ if [ "extract" = "$2" ]; then
+ echo "### start extraction"
+ rm -f /tmp/sosreport*md5
+ mkdir /tmp/sosreport_test/
+ tar xfa /tmp/sosreport*.tar* -C /tmp/sosreport_test --strip-components=1
+ if [ -s /tmp/sosreport_test/sos_logs/*errors.txt ]; then
+ FAIL=true
+ echo "!!! FAILED !!!"
+ echo "#### *errors.txt output"
+ ls -alh /tmp/sosreport_test/sos_logs/
+ cat /tmp/sosreport_test/sos_logs/*errors.txt
+ fi
+ echo "### stop extraction"
+ fi
+
+ echo "######### DONE WITH $1 #########"
+
+ if $FAIL; then
+ NUMOFFAILURES=$(($NUMOFFAILURES + 1))
+ return 1
+ else
+ return 0
+ fi
+}
+
+# If /etc/sos.conf doesn't exist let's just make it..
+if [ -f /etc/sos.conf ]; then
+ echo "/etc/sos.conf already exists"
+else
+ echo "Creating /etc/sos.conf"
+ touch /etc/sos.conf
+fi
+
+# Runs not generating sosreports
+run_expecting_sucess " -l"
+run_expecting_sucess " --list-presets"
+run_expecting_sucess " --list-profiles"
+
+# Test generating sosreports, 3 (new) options at a time
+# Trying to do --batch (1 label/archive/report/verbosity change) (other changes)
+run_expecting_sucess " --batch --build --no-env-vars " # Only --build test
+run_expecting_sucess " --batch --no-report -o hardware " extract
+run_expecting_sucess " --batch --label TEST -a -c never" extract
+run_expecting_sucess " --batch --debug --log-size 0 -c always" extract
+
+# Workaround Travis bug (requires -n lxd)
+if [ $TRAVIS = true ]; then
+ run_expecting_sucess " --batch -z xz --log-size 1 -n lxd" extract
+else
+ run_expecting_sucess " --batch -z xz --log-size 1" extract
+fi
+
+run_expecting_sucess " --batch -z gzip" extract
+run_expecting_sucess " --batch -z bzip2 -t 1 -n hardware" extract
+run_expecting_sucess " --batch --quiet -e opencl -k kernel.with-timer" extract
+run_expecting_sucess " --batch --case-id 10101 --all-logs --since=20191007" extract
+run_expecting_sucess " --batch --verbose --no-postproc" extract
+
+if [ $NUMOFFAILURES -gt 0 ]; then
+ echo "FAILED $NUMOFFAILURES"
+ exit 1
+else
+ echo "Everything worked!"
+ exit 0
+fi
+
+# vim: set et ts=4 sw=4 :